package com.mamezou.mail.html.attach;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;

import org.springframework.core.io.ClassPathResource;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.MimeMessageHelper;

import com.mamezou.mail.Customer;
import com.mamezou.mail.CustomerService;

public class CustomerServiceAttachImpl implements CustomerService {

    private JavaMailSender mailSender;
 
    public void setMailSender(JavaMailSender mailSender) {
        this.mailSender = mailSender;
    }
    
    public void regist(Customer newCustomer) {
        MimeMessage msg = mailSender.createMimeMessage();
        try {
            MimeMessageHelper helper = new MimeMessageHelper(msg,true);
        
            helper.setFrom("customerservice@localhost");
            helper.setSubject("Spring Mail abstractionւ悤");
            helper.setTo(newCustomer.getEmail());
            
            StringBuilder html = new StringBuilder();
            html.append("<html><body><H1>");
            html.append(newCustomer.getName()).append("</H1><HR/>");
            html.append("<BR>悤I<BR>");
            html.append("<body></html>");
            
            helper.setText(html.toString(),true);
            
            // FileSystemResource𗘗pƁApXɋ󔒂܂ޖÕtH_
            // i"My Documents"Ȃǁj݂ƃt@C邱ƂłȂ߁A
            // TvR[hłClassPathResource𗘗p悤ɕύXĂ܂B
            // begin>>>>>
            //FileSystemResource readme = 
            //    new FileSystemResource(new File(getClass().getResource("readme.txt").getPath()));
            //helper.addAttachment("readme.txt", readme);
            helper.addAttachment(
                    "readme.txt",
                    new ClassPathResource("/com/mamezou/mail/html/attach/readme.txt"));
            // <<<<<end
            
            mailSender.send(msg);
        } catch (MessagingException e) {
           throw new IllegalArgumentException(e);
        }
    }
    
}
