package com.mamezou.mail.html.embeddedimage;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;

import org.springframework.core.io.ClassPathResource;
import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.MimeMessageHelper;

import com.mamezou.mail.Customer;
import com.mamezou.mail.CustomerService;

public class CustomerServiceEmbeddedImageImpl implements CustomerService {

    private JavaMailSender mailSender;
 
    public void setMailSender(JavaMailSender mailSender) {
        this.mailSender = mailSender;
    }
    
    public void regist(Customer newCustomer) {
        MimeMessage msg = mailSender.createMimeMessage();
        try {
            MimeMessageHelper helper = new MimeMessageHelper(msg,true);
        
            helper.setFrom("customerservice@localhost");
            helper.setSubject("Spring Mail abstractionւ悤");
            helper.setTo(newCustomer.getEmail());
            
            StringBuilder html = new StringBuilder();
            html.append("<html><body><H1>");
            html.append(newCustomer.getName()).append("</H1><HR/>");
            html.append("<BR>悤I<BR>");
            html.append("<img src='cid:myId'>");
            html.append("<body></html>");
            
            helper.setText(html.toString(),true);
            
            // FileSystemResource𗘗pƁApXɋ󔒂܂ޖÕtH_
            // i"My Documents"Ȃǁj݂ƃt@C邱ƂłȂ߁A
            // TvR[hłClassPathResource𗘗p悤ɕύXĂ܂B
            // begin>>>>>
            //FileSystemResource img = 
            //    new FileSystemResource(new File(getClass().getResource("spring_white.png").getPath()));
            //helper.addInline("myId", img);
            helper.addInline(
                    "myId",
                    new ClassPathResource("/com/mamezou/mail/html/embeddedimage/spring_white.png"));
            // <<<<<end

            mailSender.send(msg);
        } catch (MessagingException e) {
           throw new IllegalArgumentException(e);
        }
    }
    
}
