package com.mamezou.mail.html.simple;

import java.util.Formatter;

import javax.mail.MessagingException;
import javax.mail.internet.MimeMessage;

import org.springframework.mail.javamail.JavaMailSender;
import org.springframework.mail.javamail.MimeMessageHelper;

import com.mamezou.mail.Customer;
import com.mamezou.mail.CustomerService;

public class CustomerServiceSimpleHtmlImpl implements CustomerService {

    private JavaMailSender mailSender;
 
    public void setMailSender(JavaMailSender mailSender) {
        this.mailSender = mailSender;
    }
    
    public void regist(Customer newCustomer) {
        MimeMessage msg = mailSender.createMimeMessage();
        MimeMessageHelper helper = new MimeMessageHelper(msg);
        
        try {
            helper.setFrom("customerservice@localhost");
            helper.setSubject("Spring Mail abstractionւ悤");
            helper.setTo(newCustomer.getEmail());
            
            Formatter f = new Formatter();
            f.format("<html><body><H1>%s</H1><HR/><BR>悤I</body></html>", newCustomer.getName());
            helper.setText(f.toString(),true);
            mailSender.send(msg);
        } catch (MessagingException e) {
           throw new IllegalArgumentException(e);
        }
    }
    
}
