package com.mamezou.mail.simple;

import java.util.Formatter;

import org.springframework.mail.MailException;
import org.springframework.mail.MailSender;
import org.springframework.mail.SimpleMailMessage;

import com.mamezou.mail.Customer;
import com.mamezou.mail.CustomerService;

public class CustomerServiceSimpleMessageImpl implements CustomerService {

    private MailSender mailSender;
 
    public void setMailSender(MailSender mailSender) {
        this.mailSender = mailSender;
    }
    
    public void regist(Customer newCustomer) {
        SimpleMailMessage msg = new SimpleMailMessage();
        msg.setFrom("customerservice@localhost");
        msg.setSubject("Spring Mail abstractionւ悤");
        msg.setTo(newCustomer.getEmail());
        
        Formatter f = new Formatter();
        f.format("%s悤I", newCustomer.getName());
        msg.setText(f.toString());
        try{
            mailSender.send(msg);
        }
        catch(MailException ex) {
            throw new IllegalStateException(ex);
        }        
    }
    
}
