package com.mamezou.mail.simple;

import java.util.Formatter;

import org.springframework.mail.MailException;
import org.springframework.mail.MailSender;
import org.springframework.mail.SimpleMailMessage;

import com.mamezou.mail.Customer;
import com.mamezou.mail.CustomerService;

public class CustomerServiceSimpleMessageUseTemplateImpl implements CustomerService {

    private MailSender mailSender;
    private SimpleMailMessage message;

    public void setMailSender(MailSender mailSender) {
        this.mailSender = mailSender;
    }

    public void setMessage(SimpleMailMessage message) {
        this.message = message;
    }
    
    public void regist(Customer newCustomer) {
        SimpleMailMessage msg = new SimpleMailMessage(this.message);
        msg.setTo(newCustomer.getEmail());
        Formatter f = new Formatter();
        f.format("%s悤I", newCustomer.getName());
        msg.setText(f.toString());
        try{
            mailSender.send(msg);
        }
        catch(MailException ex) {
            throw new IllegalStateException(ex);
        }        
    }
    
}
