package com.mamezou.mail.html.attach;

import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

import com.mamezou.mail.Customer;
import com.mamezou.mail.CustomerService;

public class HtmlAttachMain {

    public static void main(String[] args) {
        try {
            ApplicationContext context = new ClassPathXmlApplicationContext("com/mamezou/mail/html/attach/htmlmail_attach.xml");
            CustomerService service = (CustomerService) context.getBean("customerService");
            service.regist(new Customer("Test","test@localhost"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
